/*
 * select_i.h
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1991  Arizona Board of Regents
 *
 *
 * $Revision: 1.1 $
 * $Date: 1992/01/30 22:22:39 $
 */

#ifndef select_i_h
#define select_i_h


#define SEL_OK 1
#define SEL_FAIL 2

typedef struct  {
    long	id;
    long	status;
} SelHdr;

typedef struct {
    SelHdr	hdr;
} SState;

typedef struct {
    Map passiveMap;
    Map activeMap;
} PState;


/* By using under_s as part of the active key, we get one select
 * session per channel session.  A single channel will have separate
 * channel sessions for client and server directions, so there are separate
 * select sessions for these directions as well.
 */

typedef struct {
    long id;
    XObj lls;
} ActiveKey;
    
typedef long PassiveKey;

#endif	! select_i_h
